<template>
  <div :class="$style.searchBlock">
    <tooltip
      v-if="isShowFavoritesBtn"
      :class="$style.searchTooltip"
      title="Избранное"
    >
      <icon-btn :class="$style.searchBtn">
        <FavoritsIcon />
      </icon-btn>
    </tooltip>
    <div :class="$style.search">
      <search-input
        :class="$style.searchInput"
        ref="searchInput"
        v-model="query"
        @press-enter="search()"
        @on-clear-search="clearSearch()"
      />
      <ul
        :class="$style.autocomplete"
        v-if="isShowAutocomplete && autocompleteList.length"
      >
        <li
          v-for="(item, index) in autocompleteList"
          :key="index"
          @click="autocompleteSearch(item)"
        >
          {{ item }}
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import { SearchInput, IconBtn, Tooltip } from "./ui";
import FavoritsIcon from "@/assets/images/icons/favorits.svg";

export default {
  name: "SearchBlock",
  dependencies: "autocomplete",
  components: { SearchInput, IconBtn, FavoritsIcon, Tooltip },
  props: {
    isMobile: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      query: "",
      autocompleteList: [],
      isShowAutocomplete: false
    };
  },
  watch: {
    query(val) {
      this.updateAutocomplete(val);
    }
  },
  computed: {
    isShowFavoritesBtn() {
      return !this.isMobile || !this.isShowAutocomplete;
    }
  },
  mounted() {
    this.autocomplete.list.subscribe(list => {
      this.autocompleteList = list;
    });
  },
  methods: {
    autocompleteSearch(q) {
      this.query = q;
      this.search();
    },
    updateAutocomplete(val) {
      this.isShowAutocomplete = Boolean(val);
      this.autocomplete.changeQuery(val);
    },
    clearSearch() {
      this.isShowAutocomplete = false;
      this.query = "";
      this.search();
    },
    search() {
      this.$emit("on-search", this.query);

      // ждем обновления поисковой строки
      this.$nextTick(() => {
        this.isShowAutocomplete = false;
      });
    }
  }
};
</script>

<style lang="scss" module>
@import "../shared/styles/imports.scss";

.searchBlock {
  display: flex;

  .search {
    position: relative;
    margin-right: 16px;
    width: 100%;
  }

  .searchBtn {
    @include searchField();

    &:hover {
      background-color: $mainBgColor;
    }
  }

  .searchInput {
    flex: 1;
  }

  .searchTooltip {
    margin-right: 12px;
  }

  .autocomplete {
    @include clearUl();
    @include searchField();

    position: absolute;
    top: calc(100% - 2px);
    left: 0;
    display: block;
    width: 100%;
    height: calc(100vh * 0.4);
    overflow: auto;
    border-top: 1px solid #e0e4e7;
    border-radius: 0 0 4px 4px;

    & > li {
      padding: 10px 12px;
      font-size: 15px;
      line-height: 20px;
      color: $subTextColor;
      cursor: pointer;

      &:hover {
        background-color: $mainBgColor;
      }
    }
  }
}
</style>
